define(["app", "build/models/course"], function(app, CourseModel) {

    var CourseController = {
        model: null,
        state: {
            isNew: false
        },
        init: init,
        saveCourse: saveCourse,
        deleteCourse: deleteCourse
    };

    function init(query) {
        if (query && query.id) {
            var courses = JSON.parse(localStorage.getItem("courseBase"));
            // search for course with this id and return it
            for (var i = 0; i < courses.length; i++) {
                if (courses[i].id === query.id) {
                    CourseController.model = new CourseModel(courses[i]);
                    CourseController.state.isNew = false;
                    break;
                }
            }
        } else if (query && query.code) {
            var courses = JSON.parse(localStorage.getItem("courseBase"));
            // search for course with this code and return it
            for (var i = 0; i < courses.length; i++) {
                if (courses[i].code === query.code) {
                    CourseController.model = new CourseModel(courses[i]);
                    CourseController.state.isNew = false;
                    break;
                }
            }
        } else {
            CourseController.model = new CourseModel();
            CourseController.state.isNew = true;
        }
    }

    function deleteCourse() {
        var course = CourseController.model;
        var courses = JSON.parse(localStorage.getItem("courseBase"));
        for (var i = 0; i < courses.length; i++) {
            if (courses[i].id === course.id) {
                courses.splice(i, 1)
                break;
            }
        }
        localStorage.setItem("courseBase", JSON.stringify(courses));
        app.router.sendMessage('courses', 'update');
    }

    function saveCourse() {
        var course = CourseController.model;
        var formInput = app.f7.formToJSON('#courseEdit');
        course.setValues(formInput);
        if (!course.validate()) {
            app.f7.alert("Code and course name are both empty");
            return;
        }
        var courses = JSON.parse(localStorage.getItem("courseBase"));
        if (CourseController.state.isNew) {
            courses.push(course);
        } else {
            for (var i = 0; i < courses.length; i++) {
                if (courses[i].id === course.id) {
                    courses[i] = course;
                    break;
                }
            }
        }
        localStorage.setItem("courseBase", JSON.stringify(courses));
        app.router.sendMessage('courses', 'update');
        app.mainView.goBack();
    }

    return CourseController;
});