/** @jsx React.DOM */
define([
'app', 
'build/controllers/course', 
'build/controllers/task'
], function(app, CourseController, TaskController) {

	var $ = Framework7.$;
	
	var CourseNavbar = React.createClass({displayName: 'CourseNavbar',
		render: function() {
			return (
				React.DOM.div({className: "navbar-wrapper"}, 
			        React.DOM.div({className: "left"}, 
			            React.DOM.a({href: "#", className: "back link"}, 
			                React.DOM.i({className: "icon icon-back"}), 
			                React.DOM.span(null, "Back")
			            )
			        ), 
			        React.DOM.div({className: "center sliding"}, this.props.model.code), 
			        React.DOM.div({className: "right"}, 
			            React.DOM.a({href: 'task.html?cid=' + this.props.model.id, className: "link icon-only open-panel"}, React.DOM.i({className: "icon icon-plus"}, "+"))
			        )
			    )
			);
		}
	});

	var CoursePage = React.createClass({displayName: 'CoursePage',
		render: function() {
			return (
				React.DOM.div({className: "page-content"}, 
					CourseSummary({model: this.props.model}), 
					MultiTasksList({model: this.props.model})
				)
			)
		}
	})

	var CourseSummary = React.createClass({displayName: 'CourseSummary',
		render: function() {
			var summary = this.get_summary();
			return (
				React.DOM.div({className: "content-block course-summary"}, 
					/*<div className="content-block-title">{this.props.model.name}</div>*/
					React.DOM.div({className: "row course-name"}, 
	                    React.DOM.h1(null, this.props.model.name)
	                ), 

	                React.DOM.div({className: "row"}, 
	                	React.DOM.div({className: "col-33 cumulative-grade"}, 
	                		React.DOM.div({className: "row"}, summary.cumulative + '%'), 
	                		React.DOM.div({className: "row"}, "Cumulative")
	                	), 
	                	React.DOM.div({className: "col-34 current-grade"}, summary.current + '%'), 
	                	React.DOM.div({className: "col-33 potential-grade"}, 
	                		React.DOM.div({className: "row"}, summary.potential + '%'), 
	                		React.DOM.div({className: "row"}, "Potential")
	                	)
					)
	            )
			)
		},
		get_summary: function() {
		    var summary = {};
		    var sumWeights = 0; //for completed tasks
		    var cumulativeMark = 0
		    var totalWeight = 0; //all tasks
		    for (t in this.props.model.tasks) {
		        var task = this.props.model.tasks[t];
		        if (task.grade && task.weight) {
		            sumWeights = sumWeights + parseFloat(task.weight);
		            cumulativeMark = cumulativeMark + parseFloat(task.grade) * parseFloat(task.weight) / 100;
		        }
		        totalWeight = totalWeight + parseFloat(task.weight);
		    }
		    if (sumWeights == 0) {
		        summary.current = 0;
		    } else {
		        summary.current = (cumulativeMark / sumWeights * 100).toFixed(2);
		    }
		    summary.cumulative = cumulativeMark.toFixed(2);
		    summary.potential = (cumulativeMark + 100 - sumWeights).toFixed(2);
		    summary.totalWeight = totalWeight;
		    return summary;
		}
	})

	var MultiTasksList = React.createClass({displayName: 'MultiTasksList',
		render: function() {
			var tasks = this.categorize_tasks(this)
			return (
				React.DOM.div(null, 
					React.DOM.div({className: "content-block course-tab-buttons"}, 
		                React.DOM.div({className: "buttons-row"}, 
		                    React.DOM.a({href: "#tab1", className: "tab-link active button"}, React.DOM.i({className: "fa fa-square-o"}), " Tasks"), 
		                    React.DOM.a({href: "#tab2", className: "tab-link button"}, React.DOM.i({className: "fa fa-check-square-o"}), " Done"), 
		                    React.DOM.a({href: "#tab3", className: "tab-link button"}, React.DOM.i({className: "fa fa-pencil-square-o"}), " Marked")
		                )
	                ), 
					React.DOM.div({className: "tabs-animated-wrap"}, 
		                React.DOM.div({className: "tabs"}, 
		                    React.DOM.div({id: "tab1", className: "tab active"}, 
		                        TaskList({tasks: tasks.todo})
		                    ), 

		                    React.DOM.div({id: "tab2", className: "tab"}, 
		                        TaskList({tasks: tasks.done})
		                    ), 

		                    React.DOM.div({id: "tab3", className: "tab"}, 
		                        TaskList({tasks: tasks.marked})
		                    )
		                )
		            )
	            )
			)
		},
		categorize_tasks: function(tasks) {
			var todo = [], marked = [], done = [];
			for (var i = this.props.model.tasks.length - 1; i >= 0; i--) {
				var t = this.props.model.tasks[i];
				if (t.grade || !isNaN(parseInt(t.grade))) {
					marked.push(t)
				} else if (t.completed == true) {
					done.push(t)
				} else {
					todo.push(t)
				}
			};
			return {
				todo: todo,
				marked: marked,
				done: done
			}
		}
	})

	var TaskList = React.createClass({displayName: 'TaskList',
		render: function() {
			var sorted_tasks = _.sortBy(this.props.tasks, function(t) { return new Date(t.date) })
			var taskItems = [];
			for (var i = 0; i <= sorted_tasks.length - 1; i++) {
				taskItems.push(
					TaskItem({task: sorted_tasks[i], key: sorted_tasks[i].id})
				)
			};
			return (
				React.DOM.div({className: "list-block media-list"}, 
                    React.DOM.ul(null, 
                    	taskItems
                    )
                )
			)
		}
	})

	var SwipeoutComplete = React.createClass({displayName: 'SwipeoutComplete',
		render: function() {
			return (
				React.DOM.div({className: "swipeout-actions-left"}, 
                    React.DOM.a({href: "#", className: "swipeout-overswipe bg-green complete", onClick: this.handleComplete}, "Complete")
                )
			)
		},
		handleComplete: function() {
			var id = this.props.task.id
			TaskController.init({id:id})
	    	app.f7.swipeoutComplete('.swipeout[id="' + id + '"]', function(){
	    		TaskController.completeTask()
	    	})
		}
	})

	var TaskItem = React.createClass({displayName: 'TaskItem',
		render: function() {
			var id = this.props.task.id
			var href = "task.html?id=" + id

			var swipe_left;
			if (this.props.task.completed != true) {
				swipe_left = SwipeoutComplete({task: this.props.task})
			}

			var after = this.props.task.grade ? this.props.task.grade + '%' : this.props.task.date;

			var text = this.props.task.notes ? React.DOM.div({className: "item-text"}, this.props.task.notes) : '';

			var subtitle = this.props.task.weight ? 'w: ' + this.props.task.weight + '%' : '';
			return (
				React.DOM.li({className: "swipeout", id: id}, 
                    React.DOM.div({className: "swipeout-content"}, 
                        React.DOM.a({href: href, className: "item-content item-link"}, 
                            React.DOM.div({className: "item-inner"}, 
                                React.DOM.div({className: "item-title-row"}, 
                                    React.DOM.div({className: "item-title"}, this.props.task.name), 
                                    React.DOM.div({className: "item-after"}, after)
                                ), 
                                React.DOM.div({className: "item-subtitle"}, subtitle), 
                                text
                            )
                        )
                    ), 
                    swipe_left, 
                    React.DOM.div({className: "swipeout-actions-right"}, 
                        React.DOM.a({href: "#", className: "swipeout-overswipe bg-red delete", onClick: this.handleDelete}, "Delete")
                    )
                )
			)
		},
		handleDelete: function() {
			var id = this.props.task.id
			app.f7.confirm('Are you sure?', 'Delete Task',
			    function() {
			    	TaskController.init({id:id})
			    	app.f7.swipeoutDelete('.swipeout[id="' + id + '"]', function(){
			    		TaskController.deleteTask()
			    	})
			    }, function() {
			    	app.f7.swipeoutClose('.swipeout-opened')
			    }
			)
		}
	})

	coursePage = null;

	function update_tabs_height() {
		var $ = Framework7.$;
		$('#course-page .tabs-animated-wrap').css('height', window.innerHeight - $('.tabs-animated-wrap').offset().top + 'px') // fill bottom part of window
	}

	return {
		init: function(query) {
			CourseController.init(query);
			courseNavbar = React.renderComponent(CourseNavbar({model: CourseController.model}), document.getElementById('course-navbar'));
			coursePage = React.renderComponent(CoursePage({model: CourseController.model}), document.getElementById('course-page'));
			update_tabs_height()
		},
		receiveMessage: function(message) {
			switch (message) {
				case 'update':
					coursePage.setProps({model: CourseController.model});
					courseNavbar.setProps({model: CourseController.model});
					break;
			}
		}
	};
})