/** @jsx React.DOM */
/*global define,React */
define(['build/controllers/course'], function(CourseController) {

	var CourseNavbar = React.createClass({displayName: 'CourseNavbar',
		render: function() {
			var header = this.props.courseState.isNew ? "New course" : "Course";
			return (
				React.DOM.div({className: "navbar-wrapper"}, 
					React.DOM.div({className: "left sliding"}, 
						React.DOM.a({href: "#", className: "back link"}, 
							React.DOM.i({className: "icon icon-back"}), 
							React.DOM.span(null, "Back")
						)
					), 
					React.DOM.div({className: "center"}, header), 
					React.DOM.div({className: "right", onClick: this.handleSave}, 
						React.DOM.a({href: "#", className: "link"}, 
							React.DOM.span(null, "Save")
						)
					)
				)
			);
		},
		handleSave: function() {
			CourseController.saveCourse();
		}
	});

	var CourseField = React.createClass({displayName: 'CourseField',
		render: function () {
			var value = this.state.value;
			return (
				React.DOM.li(null, 
					React.DOM.div({className: "item-content"}, 
						/* <div className="item-media"><i className={this.props.mediaClass}></i></div> */
						React.DOM.div({className: "item-inner"}, 
							React.DOM.div({className: "item-input"}, 
								React.DOM.input({name: this.props.name, type: this.props.type, onChange: this.handleChange, 
									placeholder: this.props.placeholder, value: value})
							)
						)
					)
				)
			);
		},
		getInitialState: function () {
			return {value: this.props.value };
		},
		handleChange: function(event) {
			this.setState({value: event.target.value });
		}
	});

	var CourseForm = React.createClass({displayName: 'CourseForm',
		render: function () {
			var items = [];
			console.log(this.props.model);
			var id = this.props.model.id;
			for (var i = 0; i < this.fields.length; i++) {
				this.fields[i].value = this.props.model[this.fields[i].name];
				this.fields[i].key = i;
				items.push(CourseField(this.fields[i]));
			}

			var delete_course_button = this.props.courseState.isNew ? null : DeleteCourseButton({model: this.props.model});

			return (
				React.DOM.div({className: "page-content"}, 
					React.DOM.form({id: "courseEdit", className: "list-block"}, 
						React.DOM.ul(null, 
							React.DOM.input({name: "id", type: "hidden", value: id}), 
							items
						)
					), 
					delete_course_button
				)
			);
		},
		fields: [
			{
				mediaClass: "fa fa-book",
				name: "code",
				placeholder: "code",
				type: "text"
			},
			{
				mediaClass: "fa fa-book",
				name: "name",
				placeholder: "name",
				type: "text"
			},
			// {
			// 	mediaClass: "ion-ios7-pricetag-outline",
			// 	name: "color",
			// 	placeholder: "color",
			// 	type: "text"
			// },
		]
	});

	var DeleteCourseButton = React.createClass({displayName: 'DeleteCourseButton',
		render: function() {
			return (
				React.DOM.div({className: "list-block"}, 
					React.DOM.ul(null, 
						React.DOM.li(null, 
							React.DOM.div({className: "item-content"}, 
								React.DOM.div({className: "item-inner"}, 
									React.DOM.div({className: "item-input"}, 
										React.DOM.a({href: "#", className: "item-link list-button color-red", onClick: this.handleDelete}, "Delete")
									)
								)
							)
						)
					)
				)
			)
		},
		handleDelete: function() {
			app.f7.confirm('Are you sure?', 'Delete Course',
			    function() {
		    		CourseController.deleteCourse()
		    		app.mainView.goBack();
			    } 
			)
		}
	})

	return {
		init: function(query) {
			CourseController.init(query);
			React.renderComponent(CourseNavbar({courseState: CourseController.state}), document.getElementById('editcourse-navbar'));
			React.renderComponent(CourseForm({courseState: CourseController.state, model: CourseController.model}), document.getElementById('editcourse-page'));
		}
	};
});



