/** @jsx React.DOM */
/*global define,React */
define(['build/controllers/task', 'build/db', 'app'], function(TaskController, DB, app) {

	var $ = Framework7.$

	var TaskForm = React.createClass({displayName: 'TaskForm',
		render: function() {

			var courses = DB.getAllCourses();
			var course_options = [];
			for (var i = courses.length - 1; i >= 0; i--) {
				var option = React.DOM.option({value: courses[i].id, key: courses[i].code}, courses[i].code)
				if (this.props.model.course == courses[i].id || courses[i].id == this.props.course ) {
					course_options.unshift(option)
				} else {
					course_options.push(option)					
				}
			};

			// include delete button for existing tasks
			var delete_task_button = this.props.courseState.isNew ? null : DeleteTaskButton({model: this.props.model});

			return (
			React.DOM.div({className: "page-content"}, 
				React.DOM.form({id: "taskEdit"}, 
					React.DOM.div({className: "list-block"}, 
						React.DOM.ul(null, 
							React.DOM.input({name: "id", type: "hidden", defaultValue: this.props.model.id}), 
							React.DOM.li(null, 
								React.DOM.div({className: "item-content"}, 
									React.DOM.div({className: "item-inner"}, 
										React.DOM.div({className: "item-input"}, 
											React.DOM.input({name: "name", type: "text", placeholder: "name", defaultValue: this.props.model.name})
										)
									)
								)
							)
						)
					), 
					React.DOM.div({className: "list-block"}, 
						React.DOM.ul(null, 
							React.DOM.li(null, 
								React.DOM.div({className: "item-content"}, 
									React.DOM.div({className: "item-inner"}, 
										React.DOM.div({className: "item-title label"}, "Date"), 
										React.DOM.div({className: "item-input"}, 
											React.DOM.input({name: "date", type: "date", placeholder: "date", defaultValue: this.props.model.date})
										)
									)
								)
							), 
							React.DOM.li(null, 
								React.DOM.div({className: "item-content"}, 
									React.DOM.div({className: "item-inner"}, 
										React.DOM.div({className: "item-title label"}, "Weight (%)"), 
										React.DOM.div({className: "item-input"}, 
											React.DOM.input({name: "weight", type: "number", placeholder: "0%", defaultValue: this.props.model.weight, onBlur: this.validateNumber})
										)
									)
								)
							), 
						    React.DOM.li(null, 
						        React.DOM.div({className: "item-content"}, 
									React.DOM.div({className: "item-inner"}, 
										React.DOM.div({className: "item-title label"}, "Course"), 
										React.DOM.div({className: "item-input"}, 
											React.DOM.select({name: "course", defaultValue: "{this.props.model.course}<"}, 
												course_options
											)
										)
									)
						        )
						    ), 
							React.DOM.li(null, 
								React.DOM.div({className: "item-content"}, 
									React.DOM.div({className: "item-inner"}, 
										React.DOM.div({className: "item-input"}, 
							                React.DOM.textarea({name: "notes", placeholder: "Notes", defaultValue: this.props.model.notes})
										)
									)
								)
							)
						)
					), 
					React.DOM.div({className: "list-block"}, 
						React.DOM.ul(null, 
							React.DOM.li(null, 
								React.DOM.div({className: "item-content"}, 
									React.DOM.div({className: "item-inner"}, 
										React.DOM.div({className: "item-title label"}, "Completed"), 
										React.DOM.div({className: "item-input"}, 
											React.DOM.label({className: "label-switch"}, 
							                    React.DOM.input({name: "completed", type: "checkbox", defaultChecked: this.props.model.completed}), 
							                    React.DOM.div({className: "checkbox"})
						                	)
										)
									)
								)
							), 
							React.DOM.li(null, 
								React.DOM.div({className: "item-content"}, 
									React.DOM.div({className: "item-inner"}, 
										React.DOM.div({className: "item-title label"}, "Grade (%)"), 
										React.DOM.div({className: "item-input"}, 
											React.DOM.input({name: "grade", type: "number", placeholder: "0%", defaultValue: this.props.model.grade, onBlur: this.validateNumber})
										)
									)
								)
							)
						)
					), 
					delete_task_button
				)
			)
			)
		},
		validateNumber: function(event) {
			if (event.target.value != '' && isNaN(parseFloat(event.target.value))) {
				app.f7.alert("Couldn't parse task " + event.target.name + ", make sure it's a number.");
				event.target.value = 0;
			}
		}
	})

	var DeleteTaskButton = React.createClass({displayName: 'DeleteTaskButton',
		render: function() {
			return (
				React.DOM.div({className: "list-block"}, 
					React.DOM.ul(null, 
						React.DOM.li(null, 
							React.DOM.div({className: "item-content"}, 
								React.DOM.div({className: "item-inner"}, 
									React.DOM.div({className: "item-input"}, 
										React.DOM.a({href: "#", className: "item-link list-button color-red", onClick: this.handleDelete}, "Delete")
									)
								)
							)
						)
					)
				)
			)
		},
		handleDelete: function() {
			app.f7.confirm('Are you sure?', 'Delete Task',
			    function() {
		    		TaskController.deleteTask()
		    		app.mainView.goBack();
			    } 
			)
		}
	})

	var inputField = React.createClass({displayName: 'inputField',
		render: function() {
			if (this.props.data.type == 'textarea') {
				return ( 
					React.DOM.textarea({name: this.props.data.name, type: this.props.data.type, onChange: this.handleChange, 
						placeholder: this.props.data.placeholder, value: this.props.value})
				)
			} else if (this.props.data.type == 'checkbox') {
				return (
					React.DOM.label({className: "label-switch"}, 
	                    React.DOM.input({name: this.props.data.name, type: this.props.data.type, onChange: this.handleChange, 
						value: this.props.data.value}), 
	                    React.DOM.div({className: "checkbox"})
                	)
				)
			} else if (this.props.data.type == 'select') {
				return (
			       React.DOM.div(null)
				)
			} else {
				return (
					React.DOM.input({name: this.props.data.name, type: this.props.data.type, onChange: this.handleChange, 
						placeholder: this.props.data.placeholder, value: this.props.value})
				)
			}
			
		}
	})

	var TaskField = React.createClass({displayName: 'TaskField',
		render: function () {
			return (
				React.DOM.li(null, 
					React.DOM.div({className: "item-content"}, 
						/* <div className="item-media"><i className={this.props.mediaClass}></i></div> */
						React.DOM.div({className: "item-inner"}, 
							React.DOM.div({className: "item-input"}, 
								inputField({data: this.props, value: this.state.value})
							)
						)
					)
				)
			);
		},
		getInitialState: function () {
			return {value: this.props.value };
		},
		handleChange: function(event) {
			this.setState({value: event.target.value });
		}
	});

	// var TaskForm = React.createClass({
	// 	render: function () {
	// 		var items = [];
	// 		var id = this.props.model.id;
	// 		for (var i = 0; i < this.fields.length; i++) {
	// 			this.fields[i].value = this.props.model[this.fields[i].name];
	// 			this.fields[i].key = i;
	// 			items.push(TaskField(this.fields[i]));
	// 		}
	// 		return (
	// 			<div className="page-content">
	// 				<form id="courseEdit" className="list-block">
	// 					<ul>
	// 						<input name="id" type="hidden" value={id} />
	// 						{items}
	// 					</ul>
	// 				</form>
	// 			</div>
	// 		);
	// 	},
	// 	fields: [
	// 		{
	// 			mediaClass: "fa fa-book",
	// 			name: "name",
	// 			placeholder: "name",
	// 			type: "text"
	// 		},
	// 		{
	// 			mediaClass: "fa fa-book",
	// 			name: "date",
	// 			label: "date",
	// 			placeholder: "",
	// 			type: "date"
	// 		},
	// 		{
	// 			mediaClass: "fa fa-book",
	// 			name: "weight",
	// 			label: "date",
	// 			placeholder: "weight",
	// 			type: "number"
	// 		},
	// 		{
	// 			mediaClass: "fa fa-book",
	// 			name: "completed",
	// 			placeholder: "completed",
	// 			type: "checkbox"
	// 		},
	// 		{
	// 			mediaClass: "fa fa-book",
	// 			name: "grade",
	// 			placeholder: "grade",
	// 			type: "number"
	// 		},
	// 		{
	// 			mediaClass: "fa fa-book",
	// 			name: "notes",
	// 			placeholder: "notes",
	// 			type: "textarea"
	// 		},
	// 		{
	// 			mediaClass: "fa fa-book",
	// 			name: "course",
	// 			label: "date",
	// 			placeholder: "course",
	// 			type: "select"
	// 		},
	// 	]
	// });

	var TaskNavbar = React.createClass({displayName: 'TaskNavbar',
		render: function() {
			var style = {
				left: '22px'
			}
			var header = this.props.courseState.isNew ? "New task" : "Task";
			// var back_link = this.props.courseState.isNew ? "Back" : this.props.task.course;
			var back_link = 'Back'
			return (
				React.DOM.div({className: "navbar-wrapper"}, 
					React.DOM.div({className: "left sliding"}, 
						React.DOM.a({href: "#", className: "back link close-popup"}, 
							React.DOM.i({className: "icon icon-back"}), 
							React.DOM.span(null, back_link)
						)
					), 
					React.DOM.div({className: "center"}, header), 
					React.DOM.div({className: "right", onClick: this.handleSave}, 
						React.DOM.a({href: "#", className: "link"}, 
							React.DOM.span(null, "Save")
						)
					)
				)
			);
		},
		handleSave: function() {
			TaskController.saveTask();
		}
	});

	return {
		init: function(query) {
			TaskController.init(query);
			React.renderComponent(TaskNavbar({courseState: TaskController.state, task: TaskController.model}), document.getElementById('task-navbar'));
			React.renderComponent(TaskForm({courseState: TaskController.state, model: TaskController.model, course: query.cid}), document.getElementById('task-page'));
		}
	};
});



