/** @jsx React.DOM */
define(['app', 'build/controllers/course', 'build/db', 'build/controllers/task'], function(app, CourseController, DB, TaskController) {

	var $ = Framework7.$
	// var CourseNavbar = React.createClass({
	// 	render: function() {
	// 		return (
	// 		    <div className="navbar-wrapper">
	// 		        <div className="left">
	// 		            <a href="#" className="back link">
	// 		                <i className="icon icon-back"></i>
	// 		                <span>Back</span>
	// 		            </a>
	// 		        </div>
	// 		        <div className="center sliding">{this.props.model.code}</div>
	// 		        <div className="right">
	// 		            <a href="#" className="iconicon-only">
	// 		            	<i className="icon icon-plus">+</i>
	// 		            </a>
	// 		        </div>
	// 		    </div>
	// 		);
	// 	}
	// });

	var WorkflowPage = React.createClass({displayName: 'WorkflowPage',
		render: function() {
			var tasks = DB.getAllTasks();
			return (
				React.DOM.div({className: "page-content"}, 
					MultiTasksList({tasks: tasks})
				)
			)
		}
	})

	var MultiTasksList = React.createClass({displayName: 'MultiTasksList',
		render: function() {
			var tasks = this.categorize_tasks(this.props.tasks)
			return (
				React.DOM.div(null, 
					React.DOM.div({className: "content-block course-tab-buttons"}, 
		                React.DOM.div({className: "buttons-row"}, 
		                    React.DOM.a({href: "#tab1", className: "tab-link active button"}, React.DOM.i({className: "fa fa-square-o"}), " Tasks"), 
		                    React.DOM.a({href: "#tab2", className: "tab-link button"}, React.DOM.i({className: "fa fa-check-square-o"}), " Done"), 
		                    React.DOM.a({href: "#tab3", className: "tab-link button"}, React.DOM.i({className: "fa fa-pencil-square-o"}), " Marked")
		                )
	                ), 
					React.DOM.div({className: "tabs-animated-wrap"}, 
		                React.DOM.div({className: "tabs"}, 
		                    React.DOM.div({id: "tab1", className: "tab active"}, 
		                        DividedTaskList({tasks: tasks.todo})
		                    ), 

		                    React.DOM.div({id: "tab2", className: "tab"}, 
		                        TaskList({tasks: tasks.done})
		                    ), 

		                    React.DOM.div({id: "tab3", className: "tab"}, 
		                        TaskList({tasks: tasks.marked})
		                    )
		                )
		            )
	            )
			)
		},
		categorize_tasks: function(tasks) {
			var todo = [], marked = [], done = [];
			for (var i = tasks.length - 1; i >= 0; i--) {
				var t = tasks[i];
				if (t.grade) {
					marked.push(t)
				} else if (t.completed == true) {
					done.push(t)
				} else {
					todo.push(t)
				}
			};
			return {
				todo: todo,
				marked: marked,
				done: done
			}
		}
	})

	var DividedTaskList = React.createClass({displayName: 'DividedTaskList',
		render: function() {
			var sorted_tasks = _.sortBy(this.props.tasks, function(t) { return new Date(t.date) })
			var taskItems = [];
			var overdue = [], thisweek = [], later = [];
			var current_date = new Date();
			for (var i = 0; i <= sorted_tasks.length - 1; i++) {
				var d = new Date(sorted_tasks[i].date);
				if (d < current_date) {
					overdue.push(
						TaskItem({task: sorted_tasks[i]})
					)
				} else if (d < current_date.getDate() + 7) {
					thisweek.push(
						TaskItem({task: sorted_tasks[i]})
					)
				} else {
					later.push(
						TaskItem({task: sorted_tasks[i]})
					)
				}
			};

			if (overdue.length) {
				overdue.unshift(React.DOM.li({className: "item-divider"}, "Overdue"))
			}

			if (thisweek.length) {
				thisweek.unshift(React.DOM.li({className: "item-divider"}, "This Week"))
			}

			if (later.length) {
				later.unshift(React.DOM.li({className: "item-divider"}, "Later"))
			}

			if (sorted_tasks.length == 0) {
				var empty = React.DOM.li({className: "item-divider"}, "None")	
			} else {
				var empty = null
			}

			return (
				React.DOM.div({className: "list-block media-list"}, 
                    React.DOM.ul(null, 
                    	empty, 
                    	overdue, 
                    	thisweek, 
                    	later
                    )
                )
			)
		}
	})

	var TaskList = React.createClass({displayName: 'TaskList',
		render: function() {
			var sorted_tasks = _.sortBy(this.props.tasks, function(t) { return new Date(t.date) })
			var taskItems = [];
			for (var i = 0; i <= sorted_tasks.length - 1; i++) {
				taskItems.push(
					TaskItem({task: sorted_tasks[i]})
				)
			};
			return (
				React.DOM.div({className: "list-block media-list"}, 
                    React.DOM.ul(null, 
                    	taskItems
                    )
                )
			)
		}
	})

	
	var SwipeoutComplete = React.createClass({displayName: 'SwipeoutComplete',
		render: function() {
			return (
				React.DOM.div({className: "swipeout-actions-left"}, 
                    React.DOM.a({href: "#", className: "swipeout-overswipe bg-green complete", onClick: this.handleComplete}, "Complete")
                )
			)
		},
		handleComplete: function() {
			var id = this.props.task.id
			TaskController.init({id:id})
	    	app.f7.swipeoutComplete('.swipeout[id="' + id + '"]', function(){
	    		TaskController.completeTask()
	    	})
		}
	})

	var TaskItem = React.createClass({displayName: 'TaskItem',
		render: function() {
			var id = this.props.task.id
			var href = "task.html?id=" + id

			var swipe_left;
			if (this.props.task.completed != true) {
				swipe_left = SwipeoutComplete({task: this.props.task})
			}

			return (
				React.DOM.li({className: "swipeout", id: id}, 
                    React.DOM.div({className: "swipeout-content"}, 
                        React.DOM.a({href: href, className: "item-content item-link"}, 
                            React.DOM.div({className: "item-inner"}, 
                                React.DOM.div({className: "item-title-row"}, 
                                    React.DOM.div({className: "item-title"}, this.props.task.name), 
                                    React.DOM.div({className: "item-after"}, "w: ", this.props.task.weight, "%")
                                ), 
                                React.DOM.div({className: "item-subtitle"}, this.props.task.date), 
                                React.DOM.div({className: "item-text"}, this.props.task.notes)
                            )
                        )
                    ), 
                    swipe_left, 
                    React.DOM.div({className: "swipeout-actions-right"}, 
                        React.DOM.a({href: "#", className: "swipeout-overswipe bg-red delete", onClick: this.handleDelete}, "Delete")
                    )
                )
			)
		},
		handleDelete: function() {
			var id = this.props.task.id
			app.f7.confirm('Are you sure?', 'Delete Task',
			    function() {
			    	TaskController.init({id:id})
			    	app.f7.swipeoutDelete('.swipeout[id="' + id + '"]', function(){
			    		TaskController.deleteTask()
			    	})
			    }, function() {
			    	app.f7.swipeoutClose('.swipeout-opened')
			    }
			)
		}
	})

	function update_tabs_height() {
		var $ = Framework7.$;
		$('#workflow-page .tabs').css('height', window.innerHeight - $('.tabs').offset().top + 'px') // fill bottom part of window
	}

	workflowPage = null;

	return {
		init: function(query) {
			CourseController.init(query);
			// React.renderComponent(<CourseNavbar model = {CourseController.model}/>, document.getElementById('course-navbar'));
			workflowPage = React.renderComponent(WorkflowPage(null), document.getElementById('workflow-page'));
			update_tabs_height()
		},
		receiveMessage: function(message) {
			switch (message) {
				case 'update':
					workflowPage.setProps({model: CourseController.model});
					update_tabs_height()
					break;
			}
		}
	};
})