define(["app", "build/models/task", "build/controllers/course"], function(app, TaskModel, CourseController) {

    // TODO: refactor all of this... its a mess, use db.js

    var TaskController = {
        model: null,
        state: {
            isNew: false
        },
        init: init,
        saveTask: saveTask,
        completeTask: completeTask,
        deleteTask: deleteTask
    };

    function init(query) {
        if (query && query.id) {
            var courses = JSON.parse(localStorage.getItem('courseBase'));
            // search through all course tasks (build list first)
            var tasks = [];
            for (var i = courses.length - 1; i >= 0; i--) {
                tasks = tasks.concat(courses[i].tasks)
            };
            for (var i = 0; i < tasks.length; i++) {
                if (tasks[i].id === query.id) {
                    TaskController.model = new TaskModel(tasks[i]);
                    TaskController.state.isNew = false;
                    break;
                }
            }
        } else {
            TaskController.model = new TaskModel();
            TaskController.state.isNew = true;
        }
    }

    function completeTask() {
        var task = TaskController.model;
        var courses = JSON.parse(localStorage.getItem('courseBase'));
        CourseController.init({id:task.course})
        course = CourseController.model;

        // find the task and complete it
        for (var i = 0; i < course.tasks.length; i++) {
            if (course.tasks[i].id === task.id) {
                course.tasks[i].completed = true;
                console.log(course.tasks[i]);
                break;
            }
        }
        console.log(task);

        // update the course
        for (var i = 0; i < courses.length; i++) {
            if (courses[i].id === course.id) {
                courses[i] = course;
                break;
            }
        }
        console.log(course.tasks);

        // save it
        localStorage.setItem("courseBase", JSON.stringify(courses));
        app.router.sendMessage('course', 'update');
    }

    function deleteTask() {
        var task = TaskController.model;

        var courses = JSON.parse(localStorage.getItem('courseBase'));

        CourseController.init({id:task.course})
        course = CourseController.model;

        // find the task and remove it
        for (var i = 0; i < course.tasks.length; i++) {
            if (course.tasks[i].id === task.id) {
                course.tasks.splice(i, 1)
                break;
            }
        }

        // update the course
        for (var i = 0; i < courses.length; i++) {
            if (courses[i].id === course.id) {
                courses[i] = course;
                break;
            }
        }

        // save it
        localStorage.setItem("courseBase", JSON.stringify(courses));
        app.router.sendMessage('course', 'update');

    }

    function saveTask() {

        console.log('SAVING TASK')
        var task = TaskController.model;
        var formInput = app.f7.formToJSON('#taskEdit');
        formInput.completed = (formInput.completed[0] == "on");

        var old_course_id = task.course;
        task.setValues(formInput);
        if (!task.validate()) {
            app.f7.alert("Task name is empty");
            return;
        }

        var courses = JSON.parse(localStorage.getItem('courseBase'));

        var moving_courses;
        if (old_course_id && old_course_id != task.course) {
            // then the task has moved, delete the old one
            console.log('moving task to different course')
            CourseController.init({id:old_course_id})
            course = CourseController.model;

            // find the task and remove it
            for (var i = 0; i < course.tasks.length; i++) {
                if (course.tasks[i].id === task.id) {
                    course.tasks.splice(i, 1)
                    break;
                }
            }

            // update the course
            for (var i = 0; i < courses.length; i++) {
                if (courses[i].id === old_course_id) {
                    courses[i] = course;
                    break;
                }
            }

            var moving_courses = true;

        }

        CourseController.init({id:task.course})
        course = CourseController.model;
        console.log(course)

        // update or insert the task
        if (TaskController.state.isNew || moving_courses) {
            course.tasks.push(task);
        } else {
            for (var i = 0; i < course.tasks.length; i++) {
                if (course.tasks[i].id === task.id) {
                    course.tasks[i] = task;
                    break;
                }
            }
        }

        // save the course
        for (var i = 0; i < courses.length; i++) {
            if (courses[i].id === course.id) {
                courses[i] = course;
                break;
            }
        }

        localStorage.setItem("courseBase", JSON.stringify(courses));
        app.router.sendMessage('course', 'update');
        app.mainView.goBack();

    }

    return TaskController;
});