define(function() {
    var $ = Framework7.$
    var router = {}

    /**
     * Init router, that handle page events
     */
    router.init = function() {
        $(document).on('pageBeforeInit', function(e) {
            var page = e.detail.page;
            router.load(page.name, page.query);
        });
        $('#courses-tab-link').click(function(e) {
            router.load('courses');
        })
        // $('#task-popup').click(function(e){
        //     console.log('test');
        //     router.load('task');
        // })
    }

    /**
     * Load (or reload) view module from js code
     * @param moduleName
     * @param query
     */
    router.load = function(moduleName, query) {
        require(['build/views/' + moduleName], function(module) {
            module.init(query);
        });
    }

    /**
     * Send message to module
     * @param moduleName
     * @param query
     */
    router.sendMessage = function(moduleName, message) {
        require(['build/views/' + moduleName], function(module) {
            module.receiveMessage(message);
        });
    }

    return router;
});