/** @jsx React.DOM */
/*global define,React */
define(['build/controllers/course'], function(CourseController) {

	var CourseNavbar = React.createClass({
		render: function() {
			var header = this.props.courseState.isNew ? "New course" : "Course";
			return (
				<div className="navbar-wrapper">
					<div className="left sliding">
						<a href="#" className="back link">
							<i className="icon icon-back"></i>
							<span>Back</span>
						</a>
					</div>
					<div className="center">{header}</div>
					<div className="right" onClick={this.handleSave}>
						<a href="#" className="link">
							<span>Save</span>
						</a>
					</div>
				</div>
			);
		},
		handleSave: function() {
			CourseController.saveCourse();
		}
	});

	var CourseField = React.createClass({
		render: function () {
			var value = this.state.value;
			return (
				<li>
					<div className="item-content">
						{/* <div className="item-media"><i className={this.props.mediaClass}></i></div> */}
						<div className="item-inner">
							<div className="item-input">
								<input name={this.props.name} type={this.props.type} onChange={this.handleChange}
									placeholder={this.props.placeholder} value={value} />
							</div>
						</div>
					</div>
				</li>
			);
		},
		getInitialState: function () {
			return {value: this.props.value };
		},
		handleChange: function(event) {
			this.setState({value: event.target.value });
		}
	});

	var CourseForm = React.createClass({
		render: function () {
			var items = [];
			console.log(this.props.model);
			var id = this.props.model.id;
			for (var i = 0; i < this.fields.length; i++) {
				this.fields[i].value = this.props.model[this.fields[i].name];
				this.fields[i].key = i;
				items.push(CourseField(this.fields[i]));
			}

			var delete_course_button = this.props.courseState.isNew ? null : <DeleteCourseButton model={this.props.model} />;

			return (
				<div className="page-content">
					<form id="courseEdit" className="list-block">
						<ul>
							<input name="id" type="hidden" value={id} />
							{items}
						</ul>
					</form>
					{delete_course_button}
				</div>
			);
		},
		fields: [
			{
				mediaClass: "fa fa-book",
				name: "code",
				placeholder: "code",
				type: "text"
			},
			{
				mediaClass: "fa fa-book",
				name: "name",
				placeholder: "name",
				type: "text"
			},
			// {
			// 	mediaClass: "ion-ios7-pricetag-outline",
			// 	name: "color",
			// 	placeholder: "color",
			// 	type: "text"
			// },
		]
	});

	var DeleteCourseButton = React.createClass({
		render: function() {
			return (
				<div className="list-block">
					<ul>
						<li>
							<div className="item-content">
								<div className="item-inner">
									<div className="item-input">
										<a href="#" className="item-link list-button color-red" onClick={this.handleDelete}>Delete</a>
									</div>
								</div>
							</div>
						</li>
					</ul>
				</div>
			)
		},
		handleDelete: function() {
			app.f7.confirm('Are you sure?', 'Delete Course',
			    function() {
		    		CourseController.deleteCourse()
		    		app.mainView.goBack();
			    } 
			)
		}
	})

	return {
		init: function(query) {
			CourseController.init(query);
			React.renderComponent(<CourseNavbar courseState = {CourseController.state}/>, document.getElementById('editcourse-navbar'));
			React.renderComponent(<CourseForm courseState = {CourseController.state} model = {CourseController.model} />, document.getElementById('editcourse-page'));
		}
	};
});



