/** @jsx React.DOM */
/*global define,React */
define(['build/controllers/task', 'build/db', 'app'], function(TaskController, DB, app) {

	var $ = Framework7.$

	var TaskForm = React.createClass({
		render: function() {

			var courses = DB.getAllCourses();
			var course_options = [];
			for (var i = courses.length - 1; i >= 0; i--) {
				var option = <option value={courses[i].id} key={courses[i].code}>{courses[i].code}</option>
				if (this.props.model.course == courses[i].id || courses[i].id == this.props.course ) {
					course_options.unshift(option)
				} else {
					course_options.push(option)					
				}
			};

			// include delete button for existing tasks
			var delete_task_button = this.props.courseState.isNew ? null : <DeleteTaskButton model={this.props.model} />;

			return (
			<div className="page-content">
				<form id="taskEdit">
					<div className="list-block">
						<ul>
							<input name="id" type="hidden" defaultValue={this.props.model.id} />
							<li>
								<div className="item-content">
									<div className="item-inner">
										<div className="item-input">
											<input name="name" type="text" placeholder="name" defaultValue={this.props.model.name}/>
										</div>
									</div>
								</div>
							</li>
						</ul>
					</div>
					<div className="list-block">
						<ul>
							<li>
								<div className="item-content">
									<div className="item-inner">
										<div className="item-title label">Date</div>
										<div className="item-input">
											<input name="date" type="date" placeholder="date" defaultValue={this.props.model.date}/>
										</div>
									</div>
								</div>
							</li>
							<li>
								<div className="item-content">
									<div className="item-inner">
										<div className="item-title label">Weight (%)</div>
										<div className="item-input">
											<input name="weight" type="number" placeholder="0%" defaultValue={this.props.model.weight} onBlur={this.validateNumber}/>
										</div>
									</div>
								</div>
							</li>
						    <li>
						        <div className="item-content">
									<div className="item-inner">
										<div className="item-title label">Course</div>
										<div className="item-input">
											<select name="course" defaultValue="{this.props.model.course}<">
												{course_options}
											</select>
										</div>
									</div>
						        </div>
						    </li>
							<li>
								<div className="item-content">
									<div className="item-inner">
										<div className="item-input">
							                <textarea name="notes" placeholder="Notes" defaultValue={this.props.model.notes}/>
										</div>
									</div>
								</div>
							</li>
						</ul>
					</div>
					<div className="list-block">
						<ul>
							<li>
								<div className="item-content">
									<div className="item-inner">
										<div className="item-title label">Completed</div>
										<div className="item-input">
											<label className="label-switch">
							                    <input name="completed" type="checkbox" defaultChecked={this.props.model.completed}/>
							                    <div className="checkbox"></div>
						                	</label>
										</div>
									</div>
								</div>
							</li>
							<li>
								<div className="item-content">
									<div className="item-inner">
										<div className="item-title label">Grade (%)</div>
										<div className="item-input">
											<input name="grade" type="number" placeholder="0%" defaultValue={this.props.model.grade} onBlur={this.validateNumber}/>
										</div>
									</div>
								</div>
							</li>
						</ul>
					</div>
					{delete_task_button}
				</form>
			</div>
			)
		},
		validateNumber: function(event) {
			if (event.target.value != '' && isNaN(parseFloat(event.target.value))) {
				app.f7.alert("Couldn't parse task " + event.target.name + ", make sure it's a number.");
				event.target.value = 0;
			}
		}
	})

	var DeleteTaskButton = React.createClass({
		render: function() {
			return (
				<div className="list-block">
					<ul>
						<li>
							<div className="item-content">
								<div className="item-inner">
									<div className="item-input">
										<a href="#" className="item-link list-button color-red" onClick={this.handleDelete}>Delete</a>
									</div>
								</div>
							</div>
						</li>
					</ul>
				</div>
			)
		},
		handleDelete: function() {
			app.f7.confirm('Are you sure?', 'Delete Task',
			    function() {
		    		TaskController.deleteTask()
		    		app.mainView.goBack();
			    } 
			)
		}
	})

	var inputField = React.createClass({
		render: function() {
			if (this.props.data.type == 'textarea') {
				return ( 
					<textarea name={this.props.data.name} type={this.props.data.type} onChange={this.handleChange}
						placeholder={this.props.data.placeholder} value={this.props.value} />
				)
			} else if (this.props.data.type == 'checkbox') {
				return (
					<label className="label-switch">
	                    <input name={this.props.data.name} type={this.props.data.type} onChange={this.handleChange}
						value={this.props.data.value} />
	                    <div className="checkbox"></div>
                	</label>
				)
			} else if (this.props.data.type == 'select') {
				return (
			       <div></div>
				)
			} else {
				return (
					<input name={this.props.data.name} type={this.props.data.type} onChange={this.handleChange}
						placeholder={this.props.data.placeholder} value={this.props.value} />
				)
			}
			
		}
	})

	var TaskField = React.createClass({
		render: function () {
			return (
				<li>
					<div className="item-content">
						{/* <div className="item-media"><i className={this.props.mediaClass}></i></div> */}
						<div className="item-inner">
							<div className="item-input">
								<inputField data={this.props} value={this.state.value} />
							</div>
						</div>
					</div>
				</li>
			);
		},
		getInitialState: function () {
			return {value: this.props.value };
		},
		handleChange: function(event) {
			this.setState({value: event.target.value });
		}
	});

	// var TaskForm = React.createClass({
	// 	render: function () {
	// 		var items = [];
	// 		var id = this.props.model.id;
	// 		for (var i = 0; i < this.fields.length; i++) {
	// 			this.fields[i].value = this.props.model[this.fields[i].name];
	// 			this.fields[i].key = i;
	// 			items.push(TaskField(this.fields[i]));
	// 		}
	// 		return (
	// 			<div className="page-content">
	// 				<form id="courseEdit" className="list-block">
	// 					<ul>
	// 						<input name="id" type="hidden" value={id} />
	// 						{items}
	// 					</ul>
	// 				</form>
	// 			</div>
	// 		);
	// 	},
	// 	fields: [
	// 		{
	// 			mediaClass: "fa fa-book",
	// 			name: "name",
	// 			placeholder: "name",
	// 			type: "text"
	// 		},
	// 		{
	// 			mediaClass: "fa fa-book",
	// 			name: "date",
	// 			label: "date",
	// 			placeholder: "",
	// 			type: "date"
	// 		},
	// 		{
	// 			mediaClass: "fa fa-book",
	// 			name: "weight",
	// 			label: "date",
	// 			placeholder: "weight",
	// 			type: "number"
	// 		},
	// 		{
	// 			mediaClass: "fa fa-book",
	// 			name: "completed",
	// 			placeholder: "completed",
	// 			type: "checkbox"
	// 		},
	// 		{
	// 			mediaClass: "fa fa-book",
	// 			name: "grade",
	// 			placeholder: "grade",
	// 			type: "number"
	// 		},
	// 		{
	// 			mediaClass: "fa fa-book",
	// 			name: "notes",
	// 			placeholder: "notes",
	// 			type: "textarea"
	// 		},
	// 		{
	// 			mediaClass: "fa fa-book",
	// 			name: "course",
	// 			label: "date",
	// 			placeholder: "course",
	// 			type: "select"
	// 		},
	// 	]
	// });

	var TaskNavbar = React.createClass({
		render: function() {
			var style = {
				left: '22px'
			}
			var header = this.props.courseState.isNew ? "New task" : "Task";
			// var back_link = this.props.courseState.isNew ? "Back" : this.props.task.course;
			var back_link = 'Back'
			return (
				<div className="navbar-wrapper">
					<div className="left sliding">
						<a href="#" className="back link close-popup">
							<i className="icon icon-back"></i>
							<span>{back_link}</span>
						</a>
					</div>
					<div className="center">{header}</div>
					<div className="right" onClick={this.handleSave}>
						<a href="#" className="link">
							<span>Save</span>
						</a>
					</div>
				</div>
			);
		},
		handleSave: function() {
			TaskController.saveTask();
		}
	});

	return {
		init: function(query) {
			TaskController.init(query);
			React.renderComponent(<TaskNavbar courseState = {TaskController.state} task = {TaskController.model}/>, document.getElementById('task-navbar'));
			React.renderComponent(<TaskForm courseState = {TaskController.state} model = {TaskController.model}  course={query.cid}/>, document.getElementById('task-page'));
		}
	};
});



