/** @jsx React.DOM */
define(['app', 'build/controllers/course', 'build/db', 'build/controllers/task'], function(app, CourseController, DB, TaskController) {

	var $ = Framework7.$
	// var CourseNavbar = React.createClass({
	// 	render: function() {
	// 		return (
	// 		    <div className="navbar-wrapper">
	// 		        <div className="left">
	// 		            <a href="#" className="back link">
	// 		                <i className="icon icon-back"></i>
	// 		                <span>Back</span>
	// 		            </a>
	// 		        </div>
	// 		        <div className="center sliding">{this.props.model.code}</div>
	// 		        <div className="right">
	// 		            <a href="#" className="iconicon-only">
	// 		            	<i className="icon icon-plus">+</i>
	// 		            </a>
	// 		        </div>
	// 		    </div>
	// 		);
	// 	}
	// });

	var WorkflowPage = React.createClass({
		render: function() {
			var tasks = DB.getAllTasks();
			return (
				<div className="page-content">
					<MultiTasksList tasks={tasks} />
				</div>
			)
		}
	})

	var MultiTasksList = React.createClass({
		render: function() {
			var tasks = this.categorize_tasks(this.props.tasks)
			return (
				<div>
					<div className="content-block course-tab-buttons">
		                <div className="buttons-row">
		                    <a href="#tab1" className="tab-link active button"><i className="fa fa-square-o"></i> Tasks</a>
		                    <a href="#tab2" className="tab-link button"><i className="fa fa-check-square-o"></i> Done</a>
		                    <a href="#tab3" className="tab-link button"><i className="fa fa-pencil-square-o"></i> Marked</a>
		                </div>
	                </div>
					<div className="tabs-animated-wrap">
		                <div className="tabs">
		                    <div id="tab1" className="tab active">
		                        <DividedTaskList tasks={tasks.todo} />
		                    </div>

		                    <div id="tab2" className="tab">
		                        <TaskList tasks={tasks.done} />
		                    </div>

		                    <div id="tab3" className="tab">
		                        <TaskList tasks={tasks.marked} />
		                    </div>
		                </div>
		            </div>
	            </div>
			)
		},
		categorize_tasks: function(tasks) {
			var todo = [], marked = [], done = [];
			for (var i = tasks.length - 1; i >= 0; i--) {
				var t = tasks[i];
				if (t.grade) {
					marked.push(t)
				} else if (t.completed == true) {
					done.push(t)
				} else {
					todo.push(t)
				}
			};
			return {
				todo: todo,
				marked: marked,
				done: done
			}
		}
	})

	var DividedTaskList = React.createClass({
		render: function() {
			var sorted_tasks = _.sortBy(this.props.tasks, function(t) { return new Date(t.date) })
			var taskItems = [];
			var overdue = [], thisweek = [], later = [];
			var current_date = new Date();
			for (var i = 0; i <= sorted_tasks.length - 1; i++) {
				var d = new Date(sorted_tasks[i].date);
				if (d < current_date) {
					overdue.push(
						<TaskItem task={sorted_tasks[i]} />
					)
				} else if (d < current_date.getDate() + 7) {
					thisweek.push(
						<TaskItem task={sorted_tasks[i]} />
					)
				} else {
					later.push(
						<TaskItem task={sorted_tasks[i]} />
					)
				}
			};

			if (overdue.length) {
				overdue.unshift(<li className="item-divider">Overdue</li>)
			}

			if (thisweek.length) {
				thisweek.unshift(<li className="item-divider">This Week</li>)
			}

			if (later.length) {
				later.unshift(<li className="item-divider">Later</li>)
			}

			if (sorted_tasks.length == 0) {
				var empty = <li className="item-divider">None</li>	
			} else {
				var empty = null
			}

			return (
				<div className="list-block media-list">
                    <ul>
                    	{empty}
                    	{overdue}
                    	{thisweek}
                    	{later}
                    </ul>
                </div>
			)
		}
	})

	var TaskList = React.createClass({
		render: function() {
			var sorted_tasks = _.sortBy(this.props.tasks, function(t) { return new Date(t.date) })
			var taskItems = [];
			for (var i = 0; i <= sorted_tasks.length - 1; i++) {
				taskItems.push(
					<TaskItem task={sorted_tasks[i]} />
				)
			};
			return (
				<div className="list-block media-list">
                    <ul>
                    	{taskItems}
                    </ul>
                </div>
			)
		}
	})

	
	var SwipeoutComplete = React.createClass({
		render: function() {
			return (
				<div className="swipeout-actions-left">
                    <a href="#" className="swipeout-overswipe bg-green complete" onClick={this.handleComplete}>Complete</a>
                </div>
			)
		},
		handleComplete: function() {
			var id = this.props.task.id
			TaskController.init({id:id})
	    	app.f7.swipeoutComplete('.swipeout[id="' + id + '"]', function(){
	    		TaskController.completeTask()
	    	})
		}
	})

	var TaskItem = React.createClass({
		render: function() {
			var id = this.props.task.id
			var href = "task.html?id=" + id

			var swipe_left;
			if (this.props.task.completed != true) {
				swipe_left = <SwipeoutComplete task={this.props.task} />
			}

			return (
				<li className="swipeout" id={id}>
                    <div className="swipeout-content">
                        <a href={href} className="item-content item-link">
                            <div className="item-inner">
                                <div className="item-title-row">
                                    <div className="item-title">{this.props.task.name}</div>
                                    <div className="item-after">w: {this.props.task.weight}%</div>
                                </div>
                                <div className="item-subtitle">{this.props.task.date}</div>
                                <div className="item-text">{this.props.task.notes}</div>
                            </div>
                        </a>
                    </div>
                    {swipe_left}
                    <div className="swipeout-actions-right">
                        <a href="#" className="swipeout-overswipe bg-red delete" onClick={this.handleDelete}>Delete</a>
                    </div>
                </li>
			)
		},
		handleDelete: function() {
			var id = this.props.task.id
			app.f7.confirm('Are you sure?', 'Delete Task',
			    function() {
			    	TaskController.init({id:id})
			    	app.f7.swipeoutDelete('.swipeout[id="' + id + '"]', function(){
			    		TaskController.deleteTask()
			    	})
			    }, function() {
			    	app.f7.swipeoutClose('.swipeout-opened')
			    }
			)
		}
	})

	function update_tabs_height() {
		var $ = Framework7.$;
		$('#workflow-page .tabs').css('height', window.innerHeight - $('.tabs').offset().top + 'px') // fill bottom part of window
	}

	workflowPage = null;

	return {
		init: function(query) {
			CourseController.init(query);
			// React.renderComponent(<CourseNavbar model = {CourseController.model}/>, document.getElementById('course-navbar'));
			workflowPage = React.renderComponent(<WorkflowPage />, document.getElementById('workflow-page'));
			update_tabs_height()
		},
		receiveMessage: function(message) {
			switch (message) {
				case 'update':
					workflowPage.setProps({model: CourseController.model});
					update_tabs_height()
					break;
			}
		}
	};
})